#
/*
 *		M U L T I - D E V I C E   Q U E U E I N G   S Y S T E M
 *
 *
 *			      Douglas P. Kingston III
 *
 *				F I N D Q U E . C
 *
 *	-----------------------------------------------------------------------
 *
 *				Revision History
 *				================
 */

#include <stdio.h>
#include "queue.h"

extern	char *Qconffile;


/*
 *			F I N D Q U E
 *	Finque() returns a pointer to an array of pointers to the
 *	strings in the queue specification for the qname given.
 *	it need not be active, just exist.  Findque() returns NULL
 *	if qname is NOT a valid queue.
 */
char **
findque( qname )
char	*qname;
{
	int	filestate;
	int	argcnt;
	char	linebuf[LINESIZ];
	char	**fieldp;
	FILE	*cf;

	if(( cf = fopen (Qconffile, "r")) == NULL )
		bomb ("Cannot open configuration file (%s: %s)",
			Qconffile, sys_errlist[errno]);

	filestate = 0;
	while (fgets (linebuf, LINESIZ, cf) != NULL) {

		argcnt = parse (linebuf, &fieldp);

		/*  "Blank" line or bad line, probably a comment line */
		if (argcnt <= 0)
			continue;

		/*  Lines that start with a "-" indicate end of a section */
		if (**fieldp == '-') {
			filestate++;
			continue;
		}

		if( filestate == 2 ) {
			/*
			 *  Process a QUEUE definition, see if it exists
			 */
			if( argcnt == 0 )
				continue;
			if( strcmp( qname, *fieldp ) == SAME ) {
				fclose( cf );
				return( fieldp );
			}
		} else if( filestate == 3 )
			break;
	}
	fclose( cf );
	return( NULL );
}
