#include <stdio.h>
#include <signal.h>
#include "queue.h"

#define	tst(a,b)	(*mode == 'r'? (b) : (a))

#define	RDR	0
#define	WTR	1


FILE *
procopen( cmd, mode )
char	*cmd;
char	*mode;
{
	int p[2];
	register myside, hisside, pid;

	if(pipe(p) < 0)
		return NULL;
	myside = tst(p[WTR], p[RDR]);
	hisside = tst(p[RDR], p[WTR]);
	if((pid = fork()) == 0) {
		/* myside and hisside reverse roles in child */
		close(myside);
		dup2(hisside, tst(0, 1));
		close(hisside);

		/**** Should we open /dev/null on stderr ??? ****/

		/* clean up stray filedescriptors */
#ifndef _NFILE
		for( myside = getdtablesize()-1; myside > 2; myside--)
#else
		for( myside = _NFILE-1; myside > 2; myside--)
#endif
			close( myside );

		execl("/bin/sh", "sh", "-c", cmd, 0);
		_exit(1);
	}
	if(pid == -1)
		return NULL;

	close(hisside);
	return(fdopen(myside, mode));
}
